﻿using System;
using System.Linq;
using System.Text;
using System.ComponentModel;
using DevExpress.ExpressApp;
using DevExpress.ExpressApp.DC;
using System.Collections.Generic;
using DevExpress.ExpressApp.Model;
using DevExpress.ExpressApp.Editors;
using DevExpress.ExpressApp.Actions;
using DevExpress.ExpressApp.Updating;
using DevExpress.ExpressApp.Model.Core;
using DevExpress.ExpressApp.Model.DomainLogics;
using DevExpress.ExpressApp.Model.NodeGenerators;

namespace ASPxGroupImageProperty.Module.Web {
    using ASPxGroupImageProperty.Module.BusinessObjects;

    [ToolboxItemFilter("Xaf.Platform.Web")]
    // For more typical usage scenarios, be sure to check out https://documentation.devexpress.com/eXpressAppFramework/clsDevExpressExpressAppModuleBasetopic.aspx.
    public sealed partial class ASPxGroupImagePropertyAspNetModule : ModuleBase {
        public ASPxGroupImagePropertyAspNetModule() {
            InitializeComponent();
        }
        public override IEnumerable<ModuleUpdater> GetModuleUpdaters(IObjectSpace objectSpace, Version versionFromDB) {
            return ModuleUpdater.EmptyModuleUpdaters;
        }
        public override void Setup(XafApplication application) {
            base.Setup(application);
            application.CustomProcessShortcut += this.ApplicationCustomProcessShortcut;
        }

        private void ApplicationCustomProcessShortcut(object sender, CustomProcessShortcutEventArgs e)
        {
            if (e.Shortcut.ViewId == "TestClass_DetailView")
            {
                var objectSpace = this.Application.CreateObjectSpace();
                var testClass = new TestClass { BoolProperty1 = true, BoolProperty2 = false, BoolProperty3 = true, DateProperty1 = DateTime.Today, DateProperty2 = DateTime.Today.AddDays(-5), DateProperty3 = DateTime.Today.AddDays(3), IntProperty1 = 1, IntProperty2 = -2, IntProperty3 = 3, Name = "test Class", StringProperty1 = "string1", StringProperty2 = "string2", StringProperty3 = "string3" };
                var modelview =
                    this.Application.Model.Views.SingleOrDefault(x => x.Id == "TestClass_DetailView");
                e.View = this.Application.CreateDetailView(
                    objectSpace,
                    modelview as IModelDetailView,
                    true,
                    testClass);
                e.Handled = true;
            }
            else
            {
                return;
            }
        }
    }
}
